/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ([
/* 0 */,
/* 1 */
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__.p + "478088d8ea9dbaf9";

/***/ })
/******/ 	]);
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/publicPath */
/******/ 	(() => {
/******/ 		__webpack_require__.p = "";
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/require chunk loading */
/******/ 	(() => {
/******/ 		__webpack_require__.b = require("url").pathToFileURL(__filename);
/******/ 		
/******/ 		// object to store loaded chunks
/******/ 		// "1" means "loaded", otherwise not loaded yet
/******/ 		var installedChunks = {
/******/ 			0: 1
/******/ 		};
/******/ 		
/******/ 		// no on chunks loaded
/******/ 		
/******/ 		// no chunk install function needed
/******/ 		
/******/ 		// no chunk loading
/******/ 		
/******/ 		// no external install chunk
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

;// CONCATENATED MODULE: external "dotenv"
const external_dotenv_namespaceObject = require("dotenv");
;// CONCATENATED MODULE: external "express"
const external_express_namespaceObject = require("express");
var external_express_default = /*#__PURE__*/__webpack_require__.n(external_express_namespaceObject);
;// CONCATENATED MODULE: external "express-http-proxy"
const external_express_http_proxy_namespaceObject = require("express-http-proxy");
var external_express_http_proxy_default = /*#__PURE__*/__webpack_require__.n(external_express_http_proxy_namespaceObject);
;// CONCATENATED MODULE: external "cookie"
const external_cookie_namespaceObject = require("cookie");
var external_cookie_default = /*#__PURE__*/__webpack_require__.n(external_cookie_namespaceObject);
;// CONCATENATED MODULE: external "node:https"
const external_node_https_namespaceObject = require("node:https");
var external_node_https_default = /*#__PURE__*/__webpack_require__.n(external_node_https_namespaceObject);
;// CONCATENATED MODULE: ./src/utils.ts
/* Copyright (c) 2024 VMware, Inc. All rights reserved. -- VMware Confidential */


const authPath = '/api/k8s-token';
const proxyPath = '/api/k8s-proxy';
const nsSessionIdHttpHeader = 'ns-session-id';
const cciXsrfTokenHeader = 'CCI-XSRF-TOKEN';
const serverXsrfSuffix = Math.random().toString(16).substring(2);
const xsrfTokenSeparator = '/';
// Setting a max size allows to manage the number of tokens stored per vcenter and cleanup older tokens in-case the size increases.
const k8sTokensCacheMaxSize = 500;
/**
 * Log the information for easier debugging later.
 */
const logSetupInformation = function () {
    /**
     * In H5 plugin mode, following values are set by WCP and App Platform.
     * KUBERNETES_SERVICE_HOST 172.24.0.1
     * KUBERNETES_SERVICE_PORT_HTTPS 443
     * K8S_LOGIN_ENDPOINT undefined
     * K8S_TOKEN false
     */
    console.log('PATH_STATIC_FILES', process.env['PATH_STATIC_FILES']);
    console.log('PATH_PLUGIN_RESOURCES', process.env['PATH_PLUGIN_RESOURCES']);
    console.log('KUBERNETES_SERVICE_HOST', process.env['KUBERNETES_SERVICE_HOST']);
    console.log('KUBERNETES_SERVICE_PORT_HTTPS', process.env['KUBERNETES_SERVICE_PORT_HTTPS']);
    console.log('K8S_LOGIN_ENDPOINT', process.env['K8S_LOGIN_ENDPOINT']);
    console.log('PORT', process.env['PORT']);
    console.log('NODE_ENV', process.env['NODE_ENV']);
    console.log('K8S_TOKEN', process.env['K8S_TOKEN'] !== undefined && process.env['K8S_TOKEN'] !== '');
};
/**
 * Read the Plugin Session ID (PSID) from the respective header field.
 * Then pass the PSID over to the K8s API Login Endpoint to obtain a K8s JWT Token.
 * Eventually persist the K8s JWT Token and attach it to every future K8s API request (see below).
 * API flow is described here: https://docs.google.com/document/d/1Fp5RkbziuSzwz205SWY1wC6Je8r239OydLTerUCBoF8/edit#heading=h.hhfd5kf158kw
 */
const k8sLoginHandler = function (k8sTokensMap) {
    const k8sLoginEndpoint = process.env['K8S_LOGIN_ENDPOINT'] ||
        'https://kube-apiserver-lb-svc.kube-system.svc.cluster.local/wcp/login';
    console.log('k8sLoginEndpoint', k8sLoginEndpoint);
    let k8sToken = process.env['K8S_TOKEN'] || undefined;
    return function (req, res) {
        console.log('Got a K8s authentication request.');
        let authHeader;
        const psid = req.headers['vmware-api-session-id'];
        const authorization = req.headers['authorization'];
        if (psid) {
            authHeader = `psid ${psid}`;
        }
        else {
            authHeader = `${authorization}`;
        }
        if (!authHeader) {
            res.status(400).send("Missing 'vmware-api-session-id' or 'authorization' header.");
            return;
        }
        const options = {
            method: 'POST',
            headers: {
                Accept: 'application/json',
                Authorization: authHeader,
                'Content-Type': 'application/json',
            },
        };
        const callback = (k8sRes) => {
            let rawData = '';
            k8sRes.setEncoding('utf-8');
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            k8sRes.on('data', (chunk) => {
                if (chunk) {
                    rawData += chunk;
                }
            });
            k8sRes.on('end', () => {
                if (process.env['NODE_ENV'] === 'development') {
                    console.log('loginPayload:', rawData);
                }
                if (k8sRes.statusCode === 401) {
                    // This takes care of expired token
                    res.status(401).send(k8sRes.statusMessage);
                    return;
                }
                else {
                    let loginPayload;
                    try {
                        loginPayload = JSON.parse(rawData);
                    }
                    catch (parseError) {
                        console.error('Failed to parse loginPayload: ', rawData, parseError);
                        res.status(500).send(parseError);
                        return;
                    }
                    k8sToken = loginPayload.session_id;
                    if (k8sToken) {
                        if (k8sTokensMap.size > k8sTokensCacheMaxSize) {
                            // remove the first(oldest) token from the cache.
                            k8sTokensMap.delete(k8sTokensMap.keys().next().value);
                        }
                        // Set ns-session-id in cache.
                        k8sTokensMap.set(nsSessionId, k8sToken);
                        // Adding 'nsSessionId' to randomly generated 'serverXsrfSuffix' to prevent XSRF attacks.
                        res.status(201)
                            .cookie(cciXsrfTokenHeader, `${nsSessionId}${xsrfTokenSeparator}${serverXsrfSuffix}`, {
                            httpOnly: true,
                            secure: true,
                        })
                            .send();
                    }
                    else {
                        res.status(500).send('K8S session_id does not exist in loginPayload as:' + loginPayload);
                    }
                }
            });
        };
        const nsSessionId = req.headers[nsSessionIdHttpHeader];
        k8sToken = k8sTokensMap.get(nsSessionId);
        const nsSessionIdFromCookie = getXsrfCookieParts(req)[0];
        console.log('nsSessionId from request header:', nsSessionId);
        console.log('nsSessionId from cookie:', nsSessionIdFromCookie);
        // If request cookie has same 'ns-session-id' as coming from login request header 'ns-session-id' then we use the cached value,
        // else we login, reset the cookie and update the cache.
        if (k8sToken && nsSessionId === nsSessionIdFromCookie) {
            res.status(201).send();
        }
        else {
            const k8sReq = external_node_https_default().request(k8sLoginEndpoint, options, callback);
            k8sReq.on('error', (err) => {
                res.status(500).send(err.message);
            });
            k8sReq.end();
        }
    };
};
const getProxyOptions = function (k8sTokensMap) {
    return {
        proxyReqPathResolver: (req) => {
            const parts = req.url.split('?');
            let queryString = parts[1] || '';
            if (queryString) {
                queryString = '?' + queryString;
            }
            // Remove `proxyPath` and use the rest.
            const pathParts = req.path.split(proxyPath);
            const targetPath = pathParts[1];
            console.log(`Got a K8s proxy request to '${targetPath}${queryString}'`);
            return `${targetPath}${queryString}`;
        },
        userResDecorator: (proxyRes, proxyResData, userReq, userRes) => {
            const cookieXsrfParts = getXsrfCookieParts(userReq);
            const nsSessionId = userReq.headers[nsSessionIdHttpHeader];
            // We compare xsrfToken from cookie with nsSessionId to ensure that the current request is from an authorized user.
            if (cookieXsrfParts.length !== 2 ||
                cookieXsrfParts[0] !== nsSessionId ||
                cookieXsrfParts[1] !== serverXsrfSuffix) {
                console.log('Received nsSessionId:', cookieXsrfParts[0], 'Required nsSessionId:', nsSessionId, 'Received xsrf:', cookieXsrfParts[1], 'Required xsrf:', serverXsrfSuffix);
                userRes.status(401).send('csrf token does not match');
            }
            else {
                const nsSessionId = userRes.getHeader(nsSessionIdHttpHeader);
                if (userRes.statusCode === 401 && nsSessionId) {
                    k8sTokensMap.delete(nsSessionId);
                }
            }
            return proxyResData;
        },
        proxyReqOptDecorator: (proxyReqOpts) => {
            if (!proxyReqOpts.headers) {
                proxyReqOpts.headers = {};
            }
            const nsSessionId = proxyReqOpts.headers[nsSessionIdHttpHeader];
            // If ns-session-id is present in cache, we replace the k8sToken from cache otherwise logout and retrieve a new token.
            const k8sTokenFromCache = k8sTokensMap.get(nsSessionId);
            if (k8sTokenFromCache) {
                proxyReqOpts.headers['Authorization'] = `Bearer ${k8sTokenFromCache}`;
            }
            else {
                // log the error since token must exist in cache via request to 'authPath' endpoint.
                k8sTokensMap.delete(nsSessionId);
                const tokenMissingError = `K8s login token for ${nsSessionId} does not exist in cache`;
                // We don't throw the error (500) because without Authorization it should throw 401 automatically.
                console.error(tokenMissingError);
            }
            return proxyReqOpts;
        },
    };
};
const getXsrfCookieParts = function (request) {
    try {
        const xsrfCookie = decodeURIComponent(external_cookie_default().parse(request.headers.cookie || '')[cciXsrfTokenHeader]);
        return xsrfCookie.split(xsrfTokenSeparator);
    }
    catch (e) {
        console.error('Error parsing the xsrf token from cookie');
        return [];
    }
};

;// CONCATENATED MODULE: external "fs"
const external_fs_namespaceObject = require("fs");
var external_fs_default = /*#__PURE__*/__webpack_require__.n(external_fs_namespaceObject);
;// CONCATENATED MODULE: ./src/main.ts
/* Copyright (c) 2023 VMware, Inc. All rights reserved. -- VMware Confidential */






// We use hard-coded K8s endpoint and token only in standalone live mode.
(0,external_dotenv_namespaceObject.config)({
    path: new URL(/* asset import */ __webpack_require__(1), __webpack_require__.b).pathname,
});
const app = external_express_default()();
logSetupInformation();
/**
 * Map of ns-session-id to its k8s token.
 * Fetching the k8s token takes around 2s, so we cache the token per sessionId and avoid making this request for same sessionId.
 * TODO: Improve this logic to manage the cache size. VRAE-58647
 */
const k8sTokensMap = new Map();
/**
 * Login to supervisor to retrieve K8s token.
 */
app.post(authPath, k8sLoginHandler(k8sTokensMap));
/**
 * Proxy K8s API requests coming from the plugin front-end to the K8s API server.
 * While doing so, attach the persisted K8s JWT Token.
 */
const k8sApiEndpoint = `https://${process.env['KUBERNETES_SERVICE_HOST']}:${process.env['KUBERNETES_SERVICE_PORT_HTTPS']}`;
console.log('k8sApiEndpoint', k8sApiEndpoint);
app.all(`${proxyPath}/*`, external_express_http_proxy_default()(k8sApiEndpoint, getProxyOptions(k8sTokensMap)));
/**
 * Serve the plugin front-end: cci-ns shell app and all plugins have to be available.
 */
const frontendDistPath = process.env['PATH_STATIC_FILES'] || '';
app.use('/ui', external_express_default()["static"](new URL(frontendDistPath, "file:///jenkins/workspace/ccs-ui-preflight_master/ccs-ui/apps/cci-ns-server/src/main.ts").pathname));
/**
 * Serve the plugin manifest:
 */
const pluginResourcesPath = process.env['PATH_PLUGIN_RESOURCES'];
app.use('/plugin.json', (req, res, next) => {
    console.log('Got a request for plugin.json');
    next();
}, external_express_default()["static"](new URL(`${pluginResourcesPath}/plugin.json`, "file:///jenkins/workspace/ccs-ui-preflight_master/ccs-ui/apps/cci-ns-server/src/main.ts").pathname));
const port = process.env['PORT'] || 3333;
const welcomeMessage = `cci-ns-server has started listening on port ${port}.`;
if (process.env['NODE_ENV'] === 'development') {
    // Create an HTTP-only server for development:
    app.listen(port, () => {
        console.log(welcomeMessage, 'HTTP');
    });
}
else {
    // Create an HTTPS server with a certificate and CA certificate which have been mounted to the container in WCP environment:
    const tlsOptions = {};
    try {
        tlsOptions.cert = external_fs_default().readFileSync('/cert/tls.crt');
        tlsOptions.key = external_fs_default().readFileSync('/cert/tls.key');
        tlsOptions.ca = external_fs_default().readFileSync('/cert/ca.crt');
    }
    catch (e) {
        console.log("TLS artifacts not found in '/cert'! Using self-signed certificates.");
        tlsOptions.cert = external_fs_default().readFileSync(new URL(`${pluginResourcesPath}/cert.pem`, "file:///jenkins/workspace/ccs-ui-preflight_master/ccs-ui/apps/cci-ns-server/src/main.ts").pathname);
        tlsOptions.key = external_fs_default().readFileSync(new URL(`${pluginResourcesPath}/key.pem`, "file:///jenkins/workspace/ccs-ui-preflight_master/ccs-ui/apps/cci-ns-server/src/main.ts").pathname);
    }
    external_node_https_default().createServer(tlsOptions, app).listen(port, () => {
        console.log(welcomeMessage, 'HTTPS');
    });
}

})();

var __webpack_export_target__ = exports;
for(var i in __webpack_exports__) __webpack_export_target__[i] = __webpack_exports__[i];
if(__webpack_exports__.__esModule) Object.defineProperty(__webpack_export_target__, "__esModule", { value: true });
/******/ })()
;